classification
Title: thread_cputime isn't supported by AIX5
Type: Stage: resolved
Components: Build, Library (Lib) Versions: Python 3.9
process
Status: closed Resolution: rejected
Dependencies: Superseder:
Assigned To: Nosy List: BTaskaya, Michael.Felt, vstinner
Priority: normal Keywords:

Created on 2020-05-19 11:49 by Michael.Felt, last changed 2020-06-16 13:00 by vstinner. This issue is now closed.

Messages (9)
msg369335 - (view) Author: Michael Felt (Michael.Felt) * Date: 2020-05-19 11:49
issue40192 introduced the use of nanosecond reporting of time.

The new routine called is not available in AIX 5.3:

        xlc_r  -O -I/opt/include -O2 -qmaxmem=-1 -qarch=pwr5 -O    -I../git/python-3.9/Include/internal -IObjects -IInclude -IPython -I. -I../git/python-3.9/Include -I/opt/include   -DPy_BUILD_CORE_BUILTIN  -DPy_BUILD_CORE_BUILTIN -I../git/python-3.9/Include/internal -c ../git/python-3.9/Modules/timemodule.c -o Modules/timemodule.o
"../git/python-3.9/Modules/timemodule.c", line 1358.22: 1506-275 (S) Unexpected text tc encountered.
"../git/python-3.9/Modules/timemodule.c", line 1358.5: 1506-045 (S) Undeclared identifier thread_cputime_t.
"../git/python-3.9/Modules/timemodule.c", line 1359.29: 1506-045 (S) Undeclared identifier tc.
"../git/python-3.9/Modules/timemodule.c", line 1861.19: 1506-196 (W) Initialization between types "void*" and "int(*)(struct _object*)" is not allowed.
make: 1254-004 The error code from the last command is 1.
msg369336 - (view) Author: Batuhan Taskaya (BTaskaya) * (Python triager) Date: 2020-05-19 11:57
Does AIX 5.3 officially supported by IBM? As far as I can locate, it is deprecated long time ago.
msg369337 - (view) Author: Batuhan Taskaya (BTaskaya) * (Python triager) Date: 2020-05-19 11:59
My source: https://www.ibm.com/support/pages/aix-support-lifecycle-information
msg371238 - (view) Author: Michael Felt (Michael.Felt) * Date: 2020-06-10 20:11
No, it is not supported - asin there are no new patches - but there are
organizations that use it.

imho - those organizations are not likely to be using the latest Python
- but I have been packaging Python on AIX 5.3 and AIX 6.1 - as these
packages run unmodified on AIX 7.1 and AIX 7.2 (AIX binary compatibility).

FYI.

On 19/05/2020 13:57, Batuhan Taskaya wrote:
> Batuhan Taskaya <isidentical@gmail.com> added the comment:
>
> Does AIX 5.3 officially supported by IBM? As far as I can locate, it is deprecated long time ago.
>
> ----------
> nosy: +BTaskaya
>
> _______________________________________
> Python tracker <report@bugs.python.org>
> <https://bugs.python.org/issue40680>
> _______________________________________
>
msg371243 - (view) Author: Batuhan Taskaya (BTaskaya) * (Python triager) Date: 2020-06-10 20:35
@vstinner what are your thoughts on this? I can propose a patch that introduces a build value to generate this conditionally depending on if the system has it or not. But I am not sure about if our motivation behind this is going to be supporting (very) old versions of AIX.
msg371248 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-06-10 20:52
AIX 5 was released 16 years ago, do you we really care?
msg371249 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-06-10 20:58
According to https://www.ibm.com/support/pages/aix-support-lifecycle-information I suggest to require AIX 7.1 and newer.
msg371630 - (view) Author: Michael Felt (Michael.Felt) * Date: 2020-06-16 10:13
There is still a lot of AIX 6.1 out there, and iirc, there may be
"extended" support available.

However, at this point in time the bots run (most of the time) on AIX
7.2, -- occasionally, on AIX 7.1. And when I (personally) test - it is
usually on AIX 6.1 (e.g., to have _uuid support).

In any case, I still package using AIX 6.1 (again, _uuid mod support)
and rely on AIX binary compatibility for installations on AIX 7.1 and
AIX 7.2.

Should you be thinking/considering moving AIX to the "supported" column
- I would "gladly" embrace AIX 7.1 as a requirement.

On 10/06/2020 22:58, STINNER Victor wrote:
> STINNER Victor <vstinner@python.org> added the comment:
>
> According to https://www.ibm.com/support/pages/aix-support-lifecycle-information I suggest to require AIX 7.1 and newer.
>
> ----------
>
> _______________________________________
> Python tracker <report@bugs.python.org>
> <https://bugs.python.org/issue40680>
> _______________________________________
>
msg371651 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-06-16 13:00
> There is still a lot of AIX 6.1 out there, and iirc, there may be "extended" support available.

This issue is about AIX5 support. I'm fine with providing best effort support for AIX 6.1. If supporting AIX 6 becomes too expensive, we can consider to drop support for this version.

Anyway, I close this issue: I don't think that it's worth it to attempt to support AIX 5 in Python 3.10: AIX 5 is no longer supported by its vendor (IBM). Use Python 3.9 which seems to better support AIX 5 (don't need thread_cputime()).
History
Date User Action Args
2020-06-16 13:00:38vstinnersetstatus: open -> closed
resolution: rejected
messages: + msg371651

stage: resolved
2020-06-16 10:13:24Michael.Feltsetmessages: + msg371630
2020-06-10 20:58:49vstinnersetmessages: + msg371249
2020-06-10 20:52:55vstinnersetmessages: + msg371248
2020-06-10 20:35:18BTaskayasetnosy: + vstinner
messages: + msg371243
2020-06-10 20:11:53Michael.Feltsetmessages: + msg371238
2020-05-19 11:59:21BTaskayasetmessages: + msg369337
2020-05-19 11:57:44BTaskayasetnosy: + BTaskaya
messages: + msg369336
2020-05-19 11:49:51Michael.Feltcreate